#!/usr/bin/env python
import sys
try:
	import pygtk
	pygtk.require("2.0")
except:
	pass
try:
	import gtk
	import gtk.glade
	import pango
	import gobject
except:
	sys.exit(1)

class settings:
	def __init__(self):
		from os import popen
		loc=popen('echo $LANG | tr "_" " " | cut -d " " -f 1')
		loc=' '.join(loc)
		loc=loc.strip()
		if loc == 'pl':
			gfile='settings-pl.glade'
		else:
			gfile='settings.glade'
		
		gtk.rc_parse("rc_file_oryginal")
		self.gladefile = "/usr/share/lxwelcome/"+gfile
		self.wTree = gtk.glade.XML(self.gladefile)
		
		dic = { "on_button1_clicked" : self.pokaz,
			"on_button2_clicked" : self.otworz,
			"on_button3_clicked" : self.koniec,
			"on_button4_clicked" : self.zastosuj,
			"on_button5_clicked" : self.wczytaj,
			"window1_destroy_cb" : self.koniec,
			"on_entry1_changed" : self.change }
			
		self.wTree.signal_autoconnect(dic)
		
		from os.path import isfile
		from os import popen
		from PIL import Image
		home=popen('echo $HOME')
		home=' '.join(home)
		home=home.strip()
		if isfile (home+'/.lxwelcome'):
			pl='k'
		else:
			popen('cp /etc/lxwelcome.config '+home+'/.lxwelcome')
			
		conffile=home+'/.lxwelcome'
		cnf=open(conffile)
		image=cnf.readline()
		timeout=cnf.readline()
		cnf.close()
		image=image.strip()
		tmpimage = Image.open(image)
		tmpima = tmpimage.resize((135, 64), Image.BILINEAR)
		tmpima.save("tmp_image.png", "PNG")
		wImage=self.wTree.get_widget("image1")
		entry=self.wTree.get_widget("entry1")
		wImage.set_from_file("tmp_image.png")
		entry.set_text(image)
		popen('rm tmp_image.png')
		timeout=timeout.strip()
		timeout=eval(timeout)
		timeout=timeout/1000.0
		sek=self.wTree.get_widget("spinbutton1")
		sek.set_value(timeout)
		auto1=self.wTree.get_widget("checkbutton1")
		if isfile (home+'/.config/autostart/lxwelcome.desktop'):
			check = str(auto1.set_active(True))
		else:
			check = str(auto1.set_active(False))
		
	def pokaz(self, widget):
		from os import popen
		home=popen('echo $HOME')
		home=' '.join(home)
		home=home.strip()
		sek=self.wTree.get_widget("spinbutton1")
		sekundy=sek.get_value()
		sekundy=sekundy*1000
		sekundy=str(sekundy)
		Image=self.wTree.get_widget('entry1')
		image=Image.get_text()
		popen('mv '+home+'/.lxwelcome '+home+'/.lxwelcome-tmp')
		popen('echo "'+image+'" > '+home+'/.lxwelcome')
		popen('echo "'+sekundy+'" >> '+home+'/.lxwelcome')
		popen('lxwelcome')
		popen('mv '+home+'/.lxwelcome-tmp '+home+'/.lxwelcome')
		
	def otworz(self, widget):
		from os import popen
		from PIL import Image
		image=popen('zenity --file-selection --title "Wskarz plik graficzny"')
		image=' '.join(image)
		image=image.strip()
		tmpimage = Image.open(image)
		tmpima = tmpimage.resize((135, 64), Image.BILINEAR)
		tmpima.save("tmp_image.png", "PNG")
		wImage=self.wTree.get_widget("image1")
		entry=self.wTree.get_widget("entry1")
		wImage.set_from_file("tmp_image.png")
		entry.set_text(image)
		popen('rm tmp_image.png')
	def zastosuj(self, widget):
		from os import popen
		home=popen('echo $HOME')
		home=' '.join(home)
		home=home.strip()
		sek=self.wTree.get_widget("spinbutton1")
		sekundy=sek.get_value()
		sekundy=sekundy*1000
		sekundy=str(sekundy)
		Image=self.wTree.get_widget('entry1')
		image=Image.get_text()
		s=open(home+'/.lxwelcome', 'w')
		s.write(image)
		s.write('\n')
		s.write(sekundy)
		s.close
		auto1=self.wTree.get_widget("checkbutton1")
		check = str(auto1.get_active())
		if check == "True":
			from os.path import isdir
			if isdir (home+'/.config/autostart'):
				print ''
			else:
				from os import system
				system('mkdir '+home+'/.config/autostart')
				
			a=open(home+'/.config/autostart/lxwelcome.desktop', 'w')
			a.write('[Desktop Entry]\nName=LXWelcome\nExec=lxwelcome')
			a.close
		else:
			from os.path import isfile
			if isfile(home+'/.config/autostart/lxwelcome.desktop'):
				from os import system
				system('rm '+home+'/.config/autostart/lxwelcome.desktop')
		sys.exit()
				
	def koniec(self, widget):
		sys.exit()
		
	def change(self, widget):
		from os import popen
		from PIL import Image
		entry=self.wTree.get_widget("entry1")
		image=entry.get_text()
		tmpimage = Image.open(image)
		tmpima = tmpimage.resize((135, 64), Image.BILINEAR)
		tmpima.save("tmp_image.png", "PNG")
		wImage=self.wTree.get_widget("image1")
		entry=self.wTree.get_widget("entry1")
		wImage.set_from_file("tmp_image.png")
		entry.set_text(image)
		popen('rm tmp_image.png')
	
	def wczytaj(self, widget):
		from os.path import isfile
		from os import popen
		from PIL import Image
		home=popen('echo $HOME')
		home=' '.join(home)
		home=home.strip()
		conffile=home+'/.lxwelcome'
		cnf=open(conffile)
		image=cnf.readline()
		timeout=cnf.readline()
		cnf.close()
		image=image.strip()
		tmpimage = Image.open(image)
		tmpima = tmpimage.resize((135, 64), Image.BILINEAR)
		tmpima.save("tmp_image.png", "PNG")
		wImage=self.wTree.get_widget("image1")
		entry=self.wTree.get_widget("entry1")
		wImage.set_from_file("tmp_image.png")
		entry.set_text(image)
		popen('rm tmp_image.png')
		timeout=timeout.strip()
		timeout=eval(timeout)
		timeout=timeout/1000.0
		sek=self.wTree.get_widget("spinbutton1")
		sek.set_value(timeout)
		auto1=self.wTree.get_widget("checkbutton1")
		if isfile (home+'/.config/autostart/lxwelcome.desktop'):
			check = str(auto1.set_active(True))
		else:
			check = str(auto1.set_active(False))


if __name__ == "__main__":
	frm = settings()
	gtk.main()